#ifndef PLUTONIUM_CAPTURE_CELL_HPP_
#define PLUTONIUM_CAPTURE_CELL_HPP_

#include <Item/INuclearReactorComponent.hpp>
#include <Item/StatefulItem/StatefulItem.hpp>

/**
 * @brief Increases the amount of plutonium being generated per uranium burned.
 */
class PlutoniumCaptureCell : public StatefulItem<uint32_t>, public INuclearReactorComponent
{
public:
    static constexpr int powerOutput = 700;
    static constexpr int maxDamage = 360;

    PlutoniumCaptureCell(std::string name);

    virtual void describeInNuclearReactor(ItemStack &stack, std::ostream &os) override;
    virtual bool updateNuclearReactor(ItemStack &stack, MNuclearReactor &reactor, glm::ivec2 cellPos) override;
    virtual float getHeatConductivity(ItemStack &stack) override;
    virtual std::string getDisplayName(const ItemStack &stack) override;
    virtual void draw(GraphicsContext &context, int x, int y, const ItemStack &stack) override;
    virtual void draw3D(GraphicsContext &context, WorldDisplay &worldDisplay, glm::vec3 pos, ItemStack &stack) override;
    virtual void drawFlat(GraphicsContext &context, WorldDisplay &worldDisplay, glm::mat4 matrix, ItemStack &stack) override;
};

#endif